/*
    K8400 firmware modification based on original Version provided by Vellemann.

 Copyright (C) 2017 Holger Höhnemann

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#ifndef SERVICE_H_
#define SERVICE_H_

#include <stdio.h>

#include "MarlinHOH.h"

#define EOF_CHAR '\x1A'


enum Services  {
		Service_Dummy = 0,
		Service_Home,
		Service_Disable_Steppers,
		Service_Load_PLA_EX1,
		Service_Load_PLA_EX2,
		Service_Load_ABS_EX1,
		Service_Load_ABS_EX2,
		Service_Unload_PLA_EX1,
		Service_Unload_PLA_EX2,
		Service_Unload_ABS_EX1,
		Service_Unload_ABS_EX2,
		Service_Init_SDcard,
		Service_Start_SD,
		Service_SD_Finished_Release,
		Service_Extrude_For_Timer,
		Service_Set_T0,
		Service_Set_T1,
		Service_Filamentchange,
		Service_Last
};


class Service
{
public:
	Service();
	virtual ~Service();

	bool Printing();
	char	Get();
	bool	Is_EOF();
	void	Print (enum Services Service);

private:
	bool printing, eof;
	PGM_P code;
	char ch;

};

extern class Service service;

#endif /* SERVICE_H_ */

