/*
    K8400 firmware modification based on original Version provided by Vellemann.

 Copyright (C) 2017 Holger Höhnemann

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#ifndef SERVICES_H_
#define SERVICES_H_



#define SERVICE_DUMMY "EOF_CHAR\x1a"

#define SERVICE_STR_AUTO_HOME "G28\n\x1a"

#define SERVICE_DISABLE_STEPPERS "M84\n\x1a"

#define SERVICE_INIT_SDCARD "M21\n\x1a"

#define SERVICE_START_SD "M24\n\x1a"

#define SERVICE_SD_FINISHED_RELEASECOMMAND "M84 X Y Z E\n\x1a"

#define SERVICE_EXTRUDE_FOR_TIMER 	"M83\nG1 E5 F2000\n\x1a"

#define SERVICE_SET_T0 "T0\n\x1a"

#define SERVICE_SET_T1 "T1\n\x1a"

#define SERVICE_FILAMENTCHANGE "M600\n\x1a"

#define SERVICE_LOAD_ABS_EX1  "M117 Preparing...\n"\
		"G28\n"\
		"G90\n"\
		"M82\n"\
		"G0 F12000 X100 Y100 Z100\n"\
		"T0\n"\
		"T1\n"\
		"T0\n"\
		"M109 T0\n"\
		"G92 E0\n"\
		"M83\n"\
		"G1 E370 F2000\n"\
		"G1 E290 F1000\n"\
		"M117 Feeding filament\n"\
		"G1 E90 F50\n"\
		"G28 X Y\n"\
		"G90\n"\
		"M82\n"\
		"M104 T0 S0\n"\
		"T0\n"\
		"M84\n"\
		"M214 T0\n"\
		"M117 Vertex is ready     \n\x1a"

#define SERVICE_LOAD_ABS_EX2  "M117 Preparing...\n"\
		"G28\n"\
		"G90\n"\
		"M82\n"\
		"G0 F12000 X100 Y100 Z100\n"\
		"T1\n"\
		"T0\n"\
		"T1\n"\
		"M109 T1\n"\
		"G92 E0\n"\
		"M83\n"\
		"G1 E370 F2000\n"\
		"G1 E290 F1000\n"\
		"M117 Feeding filament\n"\
		"G1 E90 F50\n"\
		"G28 X Y\n"\
		"G90\n"\
		"M82\n"\
		"M104 T1 S0\n"\
		"T0\n"\
		"M84\n"\
		"M214 T1\n"\
		"M117 Vertex is ready     \n\x1a"


#define SERVICE_LOAD_PLA_EX1  "M117 Preparing...\n"\
		"G28\n"\
		"G90\n"\
		"M82\n"\
		"G0 F12000 X100 Y100 Z100\n"\
		"T0\n"\
		"T1\n"\
		"T0\n"\
		"M109 T0\n"\
		"G92 E0\n"\
		"M83\n"\
		"G1 E370 F2000\n"\
		"G1 E290 F1000\n"\
		"M117 Feeding filament\n"\
		"G1 E90 F50\n"\
		"G28 X Y\n"\
		"G90\n"\
		"M82\n"\
		"M104 T0 S0\n"\
		"T0\n"\
		"M84\n"\
		"M214 T0\n"\
		"M117 Vertex is ready     \n\x1a"

#define SERVICE_LOAD_PLA_EX2  "M117 Preparing...\n"\
		"G28\n"\
		"G90\n"\
		"M82\n"\
		"G0 F12000 X100 Y100 Z100\n"\
		"T1\n"\
		"T0\n"\
		"T1\n"\
		"M109 T1\n"\
		"G92 E0\n"\
		"M83\n"\
		"G1 E370 F2000\n"\
		"G1 E290 F1000\n"\
		"M117 Feeding filament\n"\
		"G1 E90 F50\n"\
		"G28 X Y\n"\
		"G90\n"\
		"M82\n"\
		"M104 T1 S0\n"\
		"T0\n"\
		"M84\n"\
		"M214 T1\n"\
		"M117 Vertex is ready     \n\x1a"

#define SERVICE_UNLOAD_PLA_EX1 	"M117 Preparing...\n"\
		"G28\n"\
		"G90\n"\
		"M82\n"\
		"G0 F12000 X100 Y100 Z100\n"\
		"T0\n"\
		"T1\n"\
		"T0\n"\
		"M109 T0\n"\
		"G92 E0\n"\
		"M83\n"\
		"G1 E15 F50\n"\
		"M117 Unloading filament\n"\
		"G1 E-370 F2000\n"\
		"G1 E-370 F2000\n"\
		"G28 X Y\n"\
		"G90\n"\
		"M82\n"\
		"M104 T0 S0\n"\
		"T0\n"\
		"M84\n"\
		"M117 Vertex is ready     \n\x1a"

#define SERVICE_UNLOAD_PLA_EX2 	"M117 Preparing...\n"\
		"G28\n"\
		"G90\n"\
		"M82\n"\
		"G0 F12000 X100 Y100 Z100\n"\
		"T1\n"\
		"T0\n"\
		"T1\n"\
		"M109 T1n"\
		"G92 E0\n"\
		"M83\n"\
		"G1 E15 F50\n"\
		"M117 Unloading filament\n"\
		"G1 E-370 F2000\n"\
		"G1 E-370 F2000\n"\
		"G28 X Y\n"\
		"G90\n"\
		"M82\n"\
		"M104 T1 S0\n"\
		"T0\n"\
		"M84\n"\
		"M117 Vertex is ready     \n\x1a"


#define SERVICE_UNLOAD_ABS_EX1 	"M117 Preparing...\n"\
		"G28\n"\
		"G90\n"\
		"M82\n"\
		"G0 F12000 X100 Y100 Z100\n"\
		"T0\n"\
		"T1\n"\
		"T0\n"\
		"M109 T0\n"\
		"G92 E0\n"\
		"M83\n"\
		"G1 E15 F50\n"\
		"M117 Unloading filament\n"\
		"G1 E-370 F2000\n"\
		"G1 E-370 F2000\n"\
		"G28 X Y\n"\
		"G90\n"\
		"M82\n"\
		"M104 T0 S0\n"\
		"T0\n"\
		"M84\n"\
		"M117 Vertex is ready     \n\x1a"

#define SERVICE_UNLOAD_ABS_EX2 	"M117 Preparing...\n"\
		"G28\n"\
		"G90\n"\
		"M82\n"\
		"G0 F12000 X100 Y100 Z100\n"\
		"T1\n"\
		"T0\n"\
		"T1\n"\
		"M109 T1\n"\
		"G92 E0\n"\
		"M83\n"\
		"G1 E15 F50\n"\
		"M117 Unloading filament\n"\
		"G1 E-370 F2000\n"\
		"G1 E-370 F2000\n"\
		"G28 X Y\n"\
		"G90\n"\
		"M82\n"\
		"M104 T1 S0\n"\
		"T0\n"\
		"M84\n"\
		"M117 Vertex is ready     \n\x1a"

#endif /* SERVICES_H_ */


