/*
    K8400 firmware modification based on original Version provided by Vellemann.

 Copyright (C) 2017 Holger Höhnemann

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

/**
 * This file is the standard Marlin version identifier file, all fields can be
 * overriden by the ones defined on _Version.h by using the Configuration.h
 * directive USE_AUTOMATIC_VERSIONING.
 */
// User-specified version info of this build to display in [Pronterface, etc] terminal window during
// startup. Implementation of an idea by Prof Braino to inform user that any changes made to this
// build by the user have been successfully uploaded into firmware.
/**
 * The STRING_VERSION_CONFIG_H represents when the binary file was built,
 * here we define this default string as the date where the latest release
 * version was tagged.
 */
#define STRING_VERSION_CONFIG_H __DATE__ " " __TIME__ // build date and time
#define STRING_CONFIG_H_AUTHOR "(Holger Hoehnemann)" //Who made the changes.

/**
 * Marlin release version identifier
 */
#define SHORT_BUILD_VERSION "V0.3-HOH"

/**
 * Verbose version identifier which should contain a reference to the location
 * from where the binary was downloaded or the source code was compiled.
 */
#define DETAILED_BUILD_VERSION SHORT_BUILD_VERSION " (hoehnemann.net)"



/**
 * @todo: Missing documentation block
 */
#define PROTOCOL_VERSION "1.0"

/**
 * Defines a generic printer name to be output to the LCD after booting Marlin.
 */
#define MACHINE_NAME "K8400 "

/**
 * The SOURCE_CODE_URL is the location where users will find the Marlin Source
 * Code which is installed on the device. In most cases —unless the manufacturer
 * has a distinct Github fork— the Source Code URL should just be the main
 * Marlin repository.
 */
#define SOURCE_CODE_URL "https://ddd.K8400.hoehnemann.net"

/**
 * Default generic printer UUID.
 */
#define DEFAULT_MACHINE_UUID "cede2a2f-41a2-4748-9b12-c55c62f367ff"

/**
 * The WEBSITE_URL is the location where users can get more information such as
 * documentation about a specific Marlin release.
 */
#define WEBSITE_URL "https://ddd.K8400.hoehnemann.net"

// LCD Splashscreen Messages
// Please note these can be 20 characters!

        #define VERSION_SPLASH_NAME " VERTEX  3D PRINTER"
        #define VERSION_SPLASH_FIRMWARE "  " SHORT_BUILD_VERSION " HEADS:" STRINGIFY(EXTRUDERS)
        #define VERSION_SPLASH_WEBSITE1 "   ddd.k8400."
        #define VERSION_SPLASH_WEBSITE2 " hoehnemann.net"

        #define VERSION_SPLASH_NAME_SMALL "VERTEX 3D PRINTER"
        #define VERSION_SPLASH_FIRMWARE_SMALL VERSION_SPLASH_FIRMWARE
        #define VERSION_SPLASH_WEBSITE1_SMALL VERSION_SPLASH_WEBSITE1
        #define VERSION_SPLASH_WEBSITE2_SMALL VERSION_SPLASH_WEBSITE2
  /* nothing here yet */

#define VERSION_M115_REPORT   "FIRMWARE_NAME: MarlinHOH " DETAILED_BUILD_VERSION " SOURCE_CODE_URL:" SOURCE_CODE_URL " PROTOCOL_VERSION:" PROTOCOL_VERSION " MACHINE_TYPE:" MACHINE_NAME " EXTRUDER_COUNT:" STRINGIFY(EXTRUDERS) " UUID:" MACHINE_UUID "\n"


