/*
    K8400 firmware modification based on original Version provided by Vellemann.

 Copyright (C) 2017 Holger Höhnemann

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#include "messages.h"
#include "language.h"

PGM_P message_list_en[]  = {
		TMESSAGEVAR(en,MSG_Marlin),
		//---------------- LCD messages: status messages
		TMESSAGEVAR(en,MSG_Wait),
		TMESSAGEVAR(en,MSG_Welcome),
		TMESSAGEVAR(en,MSG_Heating),
		TMESSAGEVAR(en,MSG_Heating_complete),
		TMESSAGEVAR(en,MSG_Printing),
		//---------------- LCD messages: Menus messages
		TMESSAGEVAR(en,MSG_Main_Menu),
		TMESSAGEVAR(en,MSG_Info),
		TMESSAGEVAR(en,MSG_Tune),
		TMESSAGEVAR(en,MSG_Prepare),
		TMESSAGEVAR(en,MSG_Control),
		TMESSAGEVAR(en,MSG_Firmware),
		TMESSAGEVAR(en,MSG_Auto_Home),
		TMESSAGEVAR(en,MSG_Load_Filament),
		TMESSAGEVAR(en,MSG_Unload_Filament),
		TMESSAGEVAR(en,MSG_Preheat_PLA),
		TMESSAGEVAR(en,MSG_Preheat_ABS),
		TMESSAGEVAR(en,MSG_Move_Axis),
		TMESSAGEVAR(en,MSG_Disable_Steppers),
		TMESSAGEVAR(en,MSG_Cooldown),
		TMESSAGEVAR(en,MSG_Extruder_offsets),
		TMESSAGEVAR(en,MSG_Temperature),
		TMESSAGEVAR(en,MSG_Motion),
		TMESSAGEVAR(en,MSG_Advanced),
		TMESSAGEVAR(en,MSG_Stopwatch),
		TMESSAGEVAR(en,MSG_Store_Eprom),
		TMESSAGEVAR(en,MSG_Load_Eprom),
		TMESSAGEVAR(en,MSG_Restore_Failsave),
		TMESSAGEVAR(en,MSG_Load_ABS_EX1),
		TMESSAGEVAR(en,MSG_Unload_ABS_EX1),
		TMESSAGEVAR(en,MSG_Load_ABS_EX2),
		TMESSAGEVAR(en,MSG_Unload_ABS_EX2),
		TMESSAGEVAR(en,MSG_Load_PLA_EX1),
		TMESSAGEVAR(en,MSG_Unload_PLA_EX1),
		TMESSAGEVAR(en,MSG_Load_PLA_EX2),
		TMESSAGEVAR(en,MSG_Unload_PLA_EX2),
		TMESSAGEVAR(en,MSG_Preheat_PLA_EX1),
		TMESSAGEVAR(en,MSG_Preheat_PLA_EX2),
		TMESSAGEVAR(en,MSG_Preheat_PLA_EXALL),
		TMESSAGEVAR(en,MSG_Preheat_ABS_EX1),
		TMESSAGEVAR(en,MSG_Preheat_ABS_EX2),
		TMESSAGEVAR(en,MSG_Preheat_ABS_EXALL),
		TMESSAGEVAR(en,MSG_Load_TEXT0),
		TMESSAGEVAR(en,MSG_Load_TEXT1),
		TMESSAGEVAR(en,MSG_Load_TEXT2),
		TMESSAGEVAR(en,MSG_Load_TEXT3),
		TMESSAGEVAR(en,MSG_No_Card),
		TMESSAGEVAR(en,MSG_Pause_Print),
		TMESSAGEVAR(en,MSG_Resume_Print),
		TMESSAGEVAR(en,MSG_Stop_Print),
		TMESSAGEVAR(en,MSG_Card_Menu),
		TMESSAGEVAR(en,MSG_Init_SDcard),
		TMESSAGEVAR(en,MSG_Change_SDcard),
		TMESSAGEVAR(en,MSG_Refresh),
		TMESSAGEVAR(en,MSG_Folder_Up),
		TMESSAGEVAR(en,MSG_Speed),
		TMESSAGEVAR(en,MSG_Move_01mm),
		TMESSAGEVAR(en,MSG_Move_1mm),
		TMESSAGEVAR(en,MSG_Move_10mm),
		TMESSAGEVAR(en,MSG_Move_X),
		TMESSAGEVAR(en,MSG_Move_Y),
		TMESSAGEVAR(en,MSG_Move_Z),
		TMESSAGEVAR(en,MSG_Move_E),
		TMESSAGEVAR(en,MSG_Start_Timer),
		TMESSAGEVAR(en,MSG_Stop_Timer),
		TMESSAGEVAR(en,MSG_Error_Maxtemp),
		TMESSAGEVAR(en,MSG_Error_Mintemp),
		//-----------------LCD-format-Strings
		TMESSAGEVAR(en,MSG_Nozzle),
		TMESSAGEVAR(en,MSG_Nozzle1),
		TMESSAGEVAR(en,MSG_Nozzle2),
		TMESSAGEVAR(en,MSG_Bed),
		TMESSAGEVAR(en,MSG_FanSpeed),
		TMESSAGEVAR(en,MSG_Adv_Press1),
		TMESSAGEVAR(en,MSG_Adv_Press2),
		TMESSAGEVAR(en,MSG_Adv_delay1),
		TMESSAGEVAR(en,MSG_Adv_delay2),
		TMESSAGEVAR(en,MSG_Flow),
		TMESSAGEVAR(en,MSG_Flow1),
		TMESSAGEVAR(en,MSG_Flow2),
		TMESSAGEVAR(en,MSG_PID_P0),
		TMESSAGEVAR(en,MSG_PID_I0),
		TMESSAGEVAR(en,MSG_PID_D0),
		TMESSAGEVAR(en,MSG_PID_C0),
		TMESSAGEVAR(en,MSG_PID_F0),
		TMESSAGEVAR(en,MSG_PID_P1),
		TMESSAGEVAR(en,MSG_PID_I1),
		TMESSAGEVAR(en,MSG_PID_D1),
		TMESSAGEVAR(en,MSG_PID_C1),
		TMESSAGEVAR(en,MSG_PID_F1),
		TMESSAGEVAR(en,MSG_PID_P99),
		TMESSAGEVAR(en,MSG_PID_I99),
		TMESSAGEVAR(en,MSG_PID_D99),
		TMESSAGEVAR(en,MSG_PID_C99),
		TMESSAGEVAR(en,MSG_PID_F99),
		TMESSAGEVAR(en,MSG_Accel),
		TMESSAGEVAR(en,MSG_VXY_Jerk),
		TMESSAGEVAR(en,MSG_VZ_Jerk),
		TMESSAGEVAR(en,MSG_VE_Jerk),
		TMESSAGEVAR(en,MSG_Vmax_X),
		TMESSAGEVAR(en,MSG_Vmax_Y),
		TMESSAGEVAR(en,MSG_Vmax_Z),
		TMESSAGEVAR(en,MSG_Vmax_E),
		TMESSAGEVAR(en,MSG_Vmin),
		TMESSAGEVAR(en,MSG_Vtrav_min),
		TMESSAGEVAR(en,MSG_A_Retract),
		TMESSAGEVAR(en,MSG_A_Travel),
		TMESSAGEVAR(en,MSG_Xsteps),
		TMESSAGEVAR(en,MSG_Ysteps),
		TMESSAGEVAR(en,MSG_Zsteps),
		TMESSAGEVAR(en,MSG_Esteps),
		TMESSAGEVAR(en,MSG_Flow_time),
		TMESSAGEVAR(en,MSG_Amax_X),
		TMESSAGEVAR(en,MSG_Amax_Y),
		TMESSAGEVAR(en,MSG_Amax_Z),
		TMESSAGEVAR(en,MSG_Amax_E),
		TMESSAGEVAR(en,MSG_Extruder_offset_X),
		TMESSAGEVAR(en,MSG_Extruder_offset_Y),

		//-----------------Serial port messages
		TMESSAGEVAR(en,MSG_SD_Init_Fail),
		TMESSAGEVAR(en,MSG_SD_Vol_Init_Fail),
		TMESSAGEVAR(en,MSG_SD_Vol_Type),
		TMESSAGEVAR(en,MSG_SD_Card_OK),
		TMESSAGEVAR(en,MSG_Begin_File_List),
		TMESSAGEVAR(en,MSG_End_File_List),
		TMESSAGEVAR(en,MSG_SD_File_Opened),
		TMESSAGEVAR(en,MSG_SD_Open_File_Fail),
		TMESSAGEVAR(en,MSG_SD_Printing_Byte),
		TMESSAGEVAR(en,MSG_SD_Not_Printing),
		TMESSAGEVAR(en,MSG_Endstops_Hit),
		TMESSAGEVAR(en,MSG_CS_Error_Load_Failsave),
		TMESSAGEVAR(en,MSG_CS_Value),
		TMESSAGEVAR(en,MSG_Invalid_Extruder),
		TMESSAGEVAR(en,MSG_Invalid_Extruder_Num),
		TMESSAGEVAR(en,MSG_Active_Extruder),
		TMESSAGEVAR(en,MSG_PID_Autotune_Invalid_Extrude),
		TMESSAGEVAR(en,MSG_PID_Autotune_Start),
		TMESSAGEVAR(en,MSG_Hotend_Stabilise),
		TMESSAGEVAR(en,MSG_Hotend_Stable_Temperature),
		TMESSAGEVAR(en,MSG_PID_Autotune_Failed),
		TMESSAGEVAR(en,MSG_PID_Autotune_Timeout),
		TMESSAGEVAR(en,MSG_PID_Autotune_Finished),
		TMESSAGEVAR(en,MSG_PID_Autotune_Finished_Updated),
		TMESSAGEVAR(en,MSG_Temp_Tune_Failed),
		TMESSAGEVAR(en,MSG_Temp_Tune_Started),
		TMESSAGEVAR(en,MSG_Temp_Tune_Fan),
		TMESSAGEVAR(en,MSG_Temp_Tune_Extrusion),
		TMESSAGEVAR(en,MSG_Temp_Heat_Result),
		TMESSAGEVAR(en,MSG_Temp_Heat_KC),
		TMESSAGEVAR(en,MSG_Maxtemp_Error_Extr),
		TMESSAGEVAR(en,MSG_Mintemp_Error_Extr),
		TMESSAGEVAR(en,MSG_Fan_Autotune_Started),
		TMESSAGEVAR(en,MSG_Repeat_Temperature_Stabilisation),
		TMESSAGEVAR(en,MSG_Temperature_Stabilisation_Abort_At),
		TMESSAGEVAR(en,MSG_Cold_Extrusion_Prevented),
		TMESSAGEVAR(en,MSG_Too_Long_Extrusion_Prevented),
		TMESSAGEVAR(en,MSG_Default_Parameters_Loaded),
		TMESSAGEVAR(en,MSG_NB_EEPROM_Bytes_Loaded),
		TMESSAGEVAR(en,MSG_Steps_Per_Unit),
		TMESSAGEVAR(en,MSG_NB_Steps_Per_Unit),
		TMESSAGEVAR(en,MSG_Max_Feedrates),
		TMESSAGEVAR(en,MSG_NB_Max_Feedrates),
		TMESSAGEVAR(en,MSG_Max_Acceleration),
		TMESSAGEVAR(en,MSG_NB_Max_Acceleration),
		TMESSAGEVAR(en,MSG_Unknown_Command),
		TMESSAGEVAR(en,MSG_Filamentchange),
		TMESSAGEVAR(en,MSG_Extruder_Nb),
		TMESSAGEVAR(en,MSG_PID_Parameter),
		TMESSAGEVAR(en,MSG_CF_Parameter)

};


messages::messages()
{
	// TODO Auto-generated constructor stub
	message_list_int = &message_list_en[0];
}

messages::~messages()
{
	// TODO Auto-generated destructor stub
}


